<?php
/*
Plugin Name: Current Location
Plugin URI: http://jdg.futbal.net/index.php/current-location-plugin/?from=current_location-plugin
Description: Gets your current location from <a href="http://www.google.com/latitude/apps/badge">Google Badge System</a>. Use <code>&lt;?php display_current_location(); ?&gt;</code> to display your current location.
Version: 1.5.1
Author: Justin D. Givens
Author URI: http://jdg.futbal.net/?from=author_name-plugin
Copyright 2011 Justin D. Givens

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
$version = '1.5.1';
DEFINE('CL_VERSION', '1.5.1');

include('cl-function.php');
include('cl-post.php');
include('cl-widget.php');
/*
function current_location_save_meta_data($post_id) {
	global $post;

	if ( 'page' == $_POST['post_type'] )
		$meta_boxes = array_merge(current_location_meta_boxes() );
	else
		$meta_boxes = array_merge(current_location_meta_boxes() );

	foreach ( $meta_boxes as $meta_box ) :

		if ( !wp_verify_nonce( $_POST[$meta_box['name'] . '_noncename'], plugin_basename( __FILE__ ) ) )
			return $post_id;

		if ( 'page' == $_POST['post_type'] && !current_user_can( 'edit_page', $post_id ) )
			return $post_id;

		elseif ( 'post' == $_POST['post_type'] && !current_user_can( 'edit_post', $post_id ) )
			return $post_id;

		$data = stripslashes( $_POST[$meta_box['name']] );
		
		if ( get_post_meta( $post_id, $meta_box['name'] ) == '' )
			add_post_meta( $post_id, $meta_box['name'], $data, true );

		elseif ( $data != get_post_meta( $post_id, $meta_box['name'], true ) )
			update_post_meta( $post_id, $meta_box['name'], $data );

		elseif ( $data == '' )
			delete_post_meta( $post_id, $meta_box['name'], get_post_meta( $post_id, $meta_box['name'], true ) );

	endforeach;
}
*/
function fixDate($incoming_timeStamp) {
	global $wp_version;
	//Function to take in the GMT and fix the time.
	//Set the timezone default if you are using WP 2.8 or higher.
	//If you don't have 2.8 or higher then it unix timestamp will return the server time. Not the Blog local time. 
	if ($wp_version >= 2.8)
	{
		date_default_timezone_set(get_option('timezone_string'));
	}
	return $incoming_timeStamp;
}

function cl_options() {
	global $version, $wp_version;
	$options = get_option("current_location_plugin");
	if (!is_array($options)) {
		$options["current_location_userid"] = "Enter Here";
		$options["current_location_date"] = "M d, Y g:i a";
		$options["current_location_temp_check"] = "";
		$options["current_location_temp_location"] = "";
		$options["current_location_map_width"] = "180";
		$options["current_location_map_height"] = "300";
		$options["current_location_map_type"] = "road";
		$options["current_location_map_zoom"] = "0";
	}

	// If the user has submitted their options, grab them here.
	if ($_POST['CL_SAVE']) {
		//Main settings were updated/saved.
		$options["current_location_userid"] = htmlspecialchars(trim($_POST["user_id"]));
		$options["current_location_date"] = htmlspecialchars(trim($_POST["format_date"]));
		$options["current_location_temp_check"] = htmlspecialchars($_POST["temp_check"]);
		//Checking to see if vacation is checked. 
		if ($options["current_location_temp_check"] == "Vac")
		{
			$options["current_location_temp_location"] = htmlspecialchars(trim($_POST["temp_location"]));
		} else {
			$options["current_location_temp_location"] = "";
		}
		//Map settings were updated/saved. 
		$width = htmlspecialchars(trim($_POST["maps_width"]));
		$height = htmlspecialchars(trim($_POST["maps_height"]));
		if ($width == "") { $width = "180"; }
		if ($height == "") { $height = "300"; }
		$options["current_location_map_width"] = $width;
		$options["current_location_map_height"] = $height;
		$options["current_location_map_type"] = htmlspecialchars(trim($_POST["maps_type"]));
		$options["current_location_map_zoom"] = htmlspecialchars(trim($_POST["maps_zoom"]));
		
		//Save the settings into the WP Options Table.
		update_option("current_location_plugin", $options);
	}
	
	if ($wp_version >= 2.8)
	{
		$cl_timezone = get_option('timezone_string');
		if ($cl_timezone == "")
		{
			$cl_timezone = "Timezone not set. Go to Settings > General";
		}
	} else {
		$cl_timezone = "Since you are using an older version of WordPress $wp_version, the timestamp output will be set to the server.";
	}

	$id = $options["current_location_userid"];
	$format_date = $options["current_location_date"];
	$temp_check = $options["current_location_temp_check"];
	$temp_location = $options["current_location_temp_location"];
	$temp_width = $options["current_location_map_width"];
	$temp_height = $options["current_location_map_height"];
	$temp_type = $options["current_location_map_type"];
	$temp_zoom = $options["current_location_map_zoom"];
	
	
	///Testing to see if Vacation is turned on. If so check it and fill in the info. If no, don't display anything.
	if ($temp_check == "Vac") { $temp_check1 = "checked=\"checked\""; $temp_location = $options["current_location_temp_location"]; } else { $temp_check1 = ""; $temp_location = ""; }
	
	//Testing to see which option needs to be selected in the maps_type field. 
	if ($temp_type == "satellite") { $satellite_select = "selected=\"selected\"";$terrain_select = "";$hybrid_select = "";$road_select = ""; } else if ($temp_type == "terrain") { $satellite_select = "";$terrain_select = "selected=\"selected\"";$hybrid_select = "";$road_select = ""; } else if ($temp_type == "hybrid") { $satellite_select = "";$terrain_select = "";$hybrid_select = "selected=\"selected\"";$road_select = ""; } else { $satellite_select = "";$terrain_select = "";$hybrid_select = "";$road_select = "selected=\"selected\""; }
	
	//Testing to see which options needs tobe selected in the maps_zoom field.
	if ($temp_zoom == "3") { $continent_select = "selected=\"selected\"";$city_select = "";$region_select = "";$country_select = "";$auto_select = ""; } else if ($temp_zoom == "10") { $continent_select = "";$city_select = "selected=\"selected\"";$region_select = "";$country_select = "";$auto_select = ""; } else if ($temp_zoom == "7") { $continent_select = "";$city_select = "";$region_select = "selected=\"selected\"";$country_select = "";$auto_select = ""; } else if ($temp_zoom == "5") { $continent_select = "";$city_select = "";$region_select = "";$country_select = "selected=\"selected\"";$auto_select = ""; } else { $continent_select = "";$city_select = "";$region_select = "";$country_select = "";$auto_select = "selected=\"selected\""; }
?>
<div class="wrap" id="current-location">
  <div style="background:transparent url(<?php echo WP_PLUGIN_URL . '/current-location';?>/icon32.png) no-repeat;float:left;height:36px;margin:14px 6px 0 0;width:36px;"><br /></div> 
	<h2>Current Location <?php echo $version;?></h2>
  <h3>Settings</h3>
  <p>New in Current Location <?php echo $version;?>: Widget Support and Post Support. See Examples of the how to use the Plugin.</p>
  <div class="clear"></div>
  <form id="cl_formOptions" name="cl_formOptions" method="post" action="">
  <table class="widefat" cellspacing="0"> 
  	<thead>
    	<tr>
      	<th width="15%">Field</th>
        <th>Value</th>
      </tr>
    </thead>
    <tfoot>
    	<tr>
      	<td colspan="2"><input type="submit" class="primary" name="CL_SAVE" id="CL_SAVE" value="Save" /></td>
      </tr>
    	<tr>
      	<th width="15%">Field</th>
        <th>Value</th>
      </tr>
    </tfoot>
    <tbody>
    	<tr class="settings">
      	<td><label for="user_id">User ID:</label></td>
        <td><input name="user_id" type="text" id="user_id" size="25" value="<?php echo $id; ?>" /></td>
      </tr>
      <tr class="explain">
      	<td>&nbsp;</td>
      	<td>Get your User ID from here: <a target="_blank" title="Gogole Badge System" href="http://www.google.com/latitude/apps/badge">Google Badge System</a>. Its is the Id number after "api?user=". <br /><strong>Example:</strong> http://www.google.com/latitude/apps/badge/api?user=-123456789&type=json User ID is: <strong>-123456789</strong></td>
      </tr>
    	<tr class="settings">
      	<td><label for="format_date">Date Format:</label></td>
        <td><input name="format_date" type="text" id="format_date" size="25" value="<?php echo $format_date; ?>" /></td>
      </tr>
      <tr class="explain">
      	<td>&nbsp;</td>
      	<td>Default Format is: <strong>M j, Y g:i a</strong>. Use the <a target="_blank" title="PHP Date" href="http://us3.php.net/manual/en/function.date.php">PHP Date</a> page to learn how to do different formating.<br /><br />Current Timezone: <strong><a href="./options-general.php" title="Change the Timezone here."><?php echo $cl_timezone; ?></a></strong></td>
      </tr>
    	<tr class="settings">
      	<td><label for="temp_location">Vacation Text:</label></td>
        <td><input style="position:relative;margin-top:0px;margin-right:5px;" name="temp_check" type="checkbox" id="temp_check" value="Vac" <?php echo $temp_check1; ?> /><input name="temp_location" type="text" id="temp_location" size="30" value="<?php echo $temp_location; ?>" /></td>
      </tr>
      <tr class="explain">
      	<td>&nbsp;</td>
      	<td>Sometimes you don't want to update your location (example: vacation). Check this box below and manually enter a location or message.</td>
      </tr>
    	<tr class="settings">
      	<td><label for="maps_width">Map/Static Width:</label></td>
        <td><input name="maps_width" type="text" id="maps_width" size="5" value="<?php echo $temp_width; ?>" /></td>
      </tr>
      <tr class="explain">
      	<td>&nbsp;</td>
      	<td>Default Setting is: <strong>180</strong></td>
      </tr>
    	<tr class="settings">
      	<td><label for="maps_height">Map/Static Height:</label></td>
        <td><input name="maps_height" type="text" id="maps_height" size="5" value="<?php echo $temp_height; ?>" /></td>
      </tr>
      <tr class="explain">
      	<td>&nbsp;</td>
      	<td>Default Setting is: <strong>300</strong></td>
      </tr>
    	<tr class="settings">
      	<td><label for="maps_type">Map/Static Type:</label></td>
        <td><select name="maps_type">
              <option <?php echo $road_select; ?> value="roadmap">Road</option>
              <option <?php echo $terrain_select; ?> value="terrain">Terrain</option>
              <option <?php echo $hybrid_select; ?> value="hybrid">Hybrid</option>
              <option <?php echo $satellite_select; ?> value="satellite">Satellite</option>
            </select></td>
      </tr>
      <tr class="explain">
      	<td>&nbsp;</td>
      	<td>Default Settings is: <strong>Road</strong></td>
      </tr>
    	<tr class="settings">
      	<td><label for="maps_zoom">Map/Static Zoom Level:</label></td>
        <td><select name="maps_zoom">
              <option <?php echo $auto_select; ?> value="0">Automatic</option>
              <option <?php echo $city_select; ?> value="10">City</option>
              <option <?php echo $region_select; ?> value="7">Region</option>
              <option <?php echo $country_select; ?> value="5">Country</option>
              <option <?php echo $continent_select; ?> value="3">Continent</option>
            </select></td>
      </tr>
      <tr class="explain">
      	<td>&nbsp;</td>
      	<td>Default Setting is: <strong>Automatic</strong></td>
      </tr>
    </tbody>
  </table>
  </form>
  <div class="clear"></div>
  <h3 style="margin-top:15px;">Examples of how to use Current Location <?php echo $version;?></h3>
  <div style="width:48%;float:left;border:1px solid #000;-moz-border-radius:6px;-khtml-border-radius:6px;-webkit-border-radius:6px;border-radius:6px; padding:5px;">
  	<h3>How to use the Plugin?</h3>
    <p>Use this in your template to display your current location: <code>display_current_location();</code>You can choose what to display or by default it will just display City Level. You can pass any of these and they will display in that order.</p>
    <ul>
      <li><strong>city</strong> :: Display Reverse Geocode (Usually City)</li>
      <li><strong>coords</strong> :: Display Coordinates</li>
      <li><strong>accuracy</strong> :: Display Accuracy In Meters</li>
      <li><strong>date</strong> :: Display Last Updated</li>
      <li><strong>map</strong> :: Display Map - Little Google Map</li>
      <li><strong>static</strong> :: Display Static Map - Without Picture Marker</li>
    </ul>
    <p>Note: To display your current location in a post, use the Current Location Options in the new post screen.</p>
  </div>
  <div style="float:left;width:48%; margin-left:10px;border:1px solid #000;-moz-border-radius:6px;-khtml-border-radius:6px;-webkit-border-radius:6px;border-radius:6px; padding:5px;">
  	<h3>Example of the Outputs?</h3>
    <ul>
    	<li><a href="./widgets.php" title="Current Location Widget">Widget Access</a></li>
      <li><code>display_current_location();</code> would output this: Nashville, TN, USA</li>
      <li><code>display_current_location("city", "accuracy");</code> would output this: Nashville, TN, USA<br />2253 meters</li>
      <li><code>display_current_location("city", "date", "coords", "accuracy");</code> would output this: Nashville, TN, USA<br/>Jun 12, 2009 2:34 am<br />-86.682559, 36.085679<br />2253 meters</li>
    </ul>
  </div>
  <div class="clear"></div>
  <script type="text/javascript">
	jQuery(document).ready(function(){
		jQuery('.settings').hover(function() {
			jQuery(this).css('background','#bbd8e7');
			jQuery(this).next('.explain').css('background','#bbd8e7');
		},function() {
			jQuery(this).css('background','#FFFFFF');
			jQuery(this).next('.explain').css('background','#FFFFFF');
		});
		jQuery('.explain').hover(function() {
			jQuery(this).prev('.settings').css('background','#bbd8e7');
			jQuery(this).css('background','#bbd8e7');
		},function() {
			jQuery(this).prev('.settings').css('background','#FFFFFF');
			jQuery(this).css('background','#FFFFFF');
		});
	});
	</script>
</div>
<?php
}


function cl_menu() {
  add_menu_page("Current Location", "Current Location",8, "current-location", "cl_options", WP_PLUGIN_URL.'/'.str_replace(basename(__FILE__),"",plugin_basename(__FILE__)) . 'icon.png');
}
add_action('admin_menu','cl_menu');
?>